<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>BSI FIDELIO eService: C:/Development/workspaces/adesso/eService/src/de/bund/bsi/fidelio/poc/service/FIDELIO.java Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">BSI FIDELIO eService
   &#160;<span id="projectnumber">1</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('_f_i_d_e_l_i_o_8java_source.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">FIDELIO.java</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_f_i_d_e_l_i_o_8java.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="keyword">package </span>de.bund.bsi.fidelio.poc.service;</div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;</div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="keyword">import</span> java.io.FileInputStream;</div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">import</span> java.io.IOException;</div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">import</span> java.security.GeneralSecurityException;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">import</span> java.security.KeyStore;</div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">import</span> java.security.cert.X509Certificate;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">import</span> java.security.interfaces.ECPrivateKey;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="keyword">import</span> java.util.Arrays;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">import</span> java.util.List;</div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">import</span> java.util.Properties;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="keyword">import</span> java.util.concurrent.ExecutionException;</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="keyword">import</span> java.util.function.Function;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">import</span> javax.crypto.Mac;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">import</span> com.lambdaworks.redis.RedisClient;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="keyword">import</span> com.lambdaworks.redis.api.StatefulRedisConnection;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">import</span> com.lambdaworks.redis.api.async.RedisAsyncCommands;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto.html">crypto</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html">CryptoProfile</a>;</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto.html">crypto</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html">CryptoProfile</a>.<a class="code" href="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type.html">Type</a>;</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto.html">crypto</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_f_i_d_e_l_i_o_secret_key.html">FIDELIOSecretKey</a>;</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format.html">format</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_request.html">FIDELIORequest</a>;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format.html">format</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a>;</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">core</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f.html">u2f</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1bund.html">bund</a>.<a class="code" href="namespacede_1_1bund_1_1bsi.html">bsi</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">fidelio</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">poc</a>.<a class="code" href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service.html">service</a>.<a class="code" href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service.html">TokenKeyService</a>.<a class="code" href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_1_1_context.html">Context</a>;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">import</span> <a class="code" href="namespacede.html">de</a>.<a class="code" href="namespacede_1_1persoapp.html">persoapp</a>.<a class="code" href="namespacede_1_1persoapp_1_1core.html">core</a>.<a class="code" href="namespacede_1_1persoapp_1_1core_1_1util.html">util</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>;</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html">   38</a></span>&#160;<span class="keyword">public</span> <span class="keyword">class </span><a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html">FIDELIO</a> {</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="comment">// size of random component in key</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keyword">final</span> <span class="keywordtype">int</span> R_SIZE = 32;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html">CryptoProfile</a> cp;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> Properties fidoProps;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> ECPrivateKey attKey;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> X509Certificate attCert;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">private</span> <span class="keyword">final</span> Function&lt;Integer, Integer&gt; globalCounter;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="comment">// 0xF1 0xDE 0x11 0x01</span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">private</span> <span class="keyword">static</span> <span class="keyword">final</span> byte[] FIDELIO_TAG = <span class="keyword">new</span> byte[] { (byte) 0xF1, (byte) 0xDE, (byte) 0x11, (byte) 0x01 };</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#aa0b65e3bedf43b1e455ca2ae33bba661">   60</a></span>&#160;    <span class="keyword">public</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#aa0b65e3bedf43b1e455ca2ae33bba661">FIDELIO</a>(<span class="keyword">final</span> Properties fidoProps) {</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keywordflow">if</span> (fidoProps == null) {</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;            <span class="keywordflow">throw</span> <span class="keyword">new</span> NullPointerException(<span class="stringliteral">&quot;properties == null&quot;</span>);</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        }</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        this.cp = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html">CryptoProfile</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a8f8dbe6962b607a2ea1c9948e809d545">getInstance</a>(<a class="code" href="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type.html">Type</a>.<a class="code" href="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type.html#a1b83f6cf7f1d4e333ae69e6052b76371">P256</a>); <span class="comment">// make configurable?</span></div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        this.fidoProps = fidoProps;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        <span class="keyword">final</span> RedisClient redisClient = RedisClient.create((String) this.fidoProps.get(<span class="stringliteral">&quot;redisServer&quot;</span>));</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keyword">final</span> StatefulRedisConnection&lt;String, String&gt; rc = redisClient.connect();</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        <span class="keyword">final</span> RedisAsyncCommands&lt;String, String&gt; ac = rc.async();</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        <span class="keyword">final</span> String redisCounterPrefix = (String) this.fidoProps.get(<span class="stringliteral">&quot;redisCounterPrefix&quot;</span>);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        this.globalCounter = (x) -&gt; {</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;            <span class="keywordflow">try</span> {</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;                <span class="keywordflow">return</span> ac.incr(redisCounterPrefix + x).get().intValue();</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;            } <span class="keywordflow">catch</span> (<span class="keyword">final</span> ExecutionException | InterruptedException ee) {</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;                ee.printStackTrace();</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;                <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;            }</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;        };</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordflow">try</span> {</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            <span class="keyword">final</span> KeyStore p12 = KeyStore.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a8f8dbe6962b607a2ea1c9948e809d545">getInstance</a>(<span class="stringliteral">&quot;PKCS12&quot;</span>);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            p12.load(<span class="keyword">new</span> FileInputStream(this.fidoProps.getProperty(<span class="stringliteral">&quot;attestationKeystore&quot;</span>, <span class="stringliteral">&quot;keystore&quot;</span>)),</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                    this.fidoProps.getProperty(<span class="stringliteral">&quot;attestationPassword&quot;</span>, <span class="stringliteral">&quot;&quot;</span>).toCharArray());</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            <span class="keyword">final</span> String firstAlias = p12.aliases().nextElement();</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            this.attKey = (ECPrivateKey) p12.getKey(firstAlias,</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;                    <span class="keyword">this</span>.fidoProps.getProperty(<span class="stringliteral">&quot;attestationPassword&quot;</span>, <span class="stringliteral">&quot;&quot;</span>).toCharArray());</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            this.attCert = (X509Certificate) p12.getCertificate(firstAlias);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        } <span class="keywordflow">catch</span> (GeneralSecurityException | IOException e) {</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            <span class="keywordflow">throw</span> <span class="keyword">new</span> IllegalStateException(e);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        }</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    }</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a690597e29e3786b988a326e4ab288dfb">  107</a></span>&#160;    <span class="keyword">public</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a690597e29e3786b988a326e4ab288dfb">doFIDOeID</a>(<span class="keyword">final</span> <a class="code" href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_1_1_context.html">Context</a> ctx, <span class="keyword">final</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_request.html">FIDELIORequest</a> fidoReq)</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;            <span class="keywordflow">throws</span> GeneralSecurityException {</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordflow">return</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a690597e29e3786b988a326e4ab288dfb">doFIDOeID</a>(ctx, fidoReq.getCommand(), fidoReq.getAppIdHash(),</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;                fidoReq.getClientDataHash(), fidoReq.getKeyHandles());</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    }</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="comment">// appIdHash -&gt; ridSupplier -&gt; getResultKDK</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="comment">// TODO: distinguish from enroll and signin despite of keyhandles</span></div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno"><a class="line" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a4cdb8a1607536210bd202223dbbf3493">  129</a></span>&#160;    <span class="keyword">public</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a4cdb8a1607536210bd202223dbbf3493">doFIDOeID</a>(<span class="keyword">final</span> <a class="code" href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_1_1_context.html">Context</a> ctx, <span class="keyword">final</span> byte command, <span class="keyword">final</span> byte[] appIdHash,</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            <span class="keyword">final</span> byte[] clientDataHash, <span class="keyword">final</span> List&lt;byte[]&gt; keyHandles)</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <span class="keywordflow">throws</span> GeneralSecurityException {</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="comment">// RandomnessExtraction and secret initialization</span></div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keyword">final</span> Mac mac = this.cp.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a99688f747f4b1eab7c9a46534c5a867b">M</a>(ctx.fKX((<span class="keywordtype">short</span>) 1));</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keyword">final</span> Function&lt;byte[], FIDELIOSecretKey&gt; fP = (x) -&gt; ctx.fKX((<span class="keywordtype">short</span>) 2, x);</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="comment">// switch(command) 1: enroll, 2: authenticate, 3: getVersion</span></div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;        <span class="keywordflow">if</span> (appIdHash != null &amp;&amp; appIdHash.length == 32 &amp;&amp; clientDataHash != null &amp;&amp; clientDataHash.length == 32) {</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;            <span class="keywordflow">if</span> (command == 1) {</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;                <span class="comment">// check for keyHandles for blacklist</span></div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                <span class="keywordflow">if</span> (keyHandles != null &amp;&amp; keyHandles.size() &gt; 0) {</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                    <span class="keywordflow">for</span> (<span class="keyword">final</span> byte[] keyHandle : keyHandles) {</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                        <span class="keywordflow">if</span> (keyHandle != null &amp;&amp; keyHandle.length == FIDELIO_TAG.length + R_SIZE + mac.getMacLength()) {</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;                            mac.update(keyHandle, 0, FIDELIO_TAG.length + R_SIZE);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                            <span class="keywordflow">if</span> (Arrays.equals(FIDELIO_TAG, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(keyHandle, 0, FIDELIO_TAG.length)) &amp;&amp;</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                                    Arrays.equals(</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                                            <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(keyHandle, FIDELIO_TAG.length + R_SIZE,</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;                                                    mac.getMacLength()),</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;                                            mac.doFinal())) {</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;                                <span class="comment">// keyHandle matched</span></div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;                                <span class="keywordflow">return</span> null;</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;                            }</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;                        }</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;                    }</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                }</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                <span class="comment">// build a &quot;FIDELIO1&quot; tagged nonce, add inner MAC to verify eID &lt;-&gt; keyhandle relationship</span></div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;                <span class="keyword">final</span> byte[] tagWithNonce = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a928e2fdf70cada5f0b6dfe324e0d0eae">concat</a>(FIDELIO_TAG, this.cp.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#acaff1853aba4cfcd123859035f114e79">R</a>(R_SIZE));</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                <span class="keyword">final</span> byte[] newKeyHandle = <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a928e2fdf70cada5f0b6dfe324e0d0eae">concat</a>(tagWithNonce, mac.doFinal(tagWithNonce));</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                <span class="keyword">final</span> byte[] userPubKey = this.cp.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a5341de0816b3ab7fb2dae4be7bafb246">Q</a>(fP.apply(newKeyHandle));</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                <span class="comment">// create response containing public key, keyHandle, token certificate and signature</span></div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;                <span class="comment">// all OK, errors are signaled using HTTP error codes atm</span></div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                <span class="keywordflow">return</span> respondEnroll(0, appIdHash, clientDataHash, userPubKey, newKeyHandle);</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;            } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == 2 &amp;&amp; keyHandles != null &amp;&amp; keyHandles.size() &gt; 0) {</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;                <span class="keywordflow">for</span> (<span class="keyword">final</span> byte[] keyHandle : keyHandles) {</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;                    <span class="keywordflow">if</span> (keyHandle != null &amp;&amp; keyHandle.length == FIDELIO_TAG.length + R_SIZE + mac.getMacLength()) {</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;                        mac.update(keyHandle, 0, FIDELIO_TAG.length + R_SIZE);</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;                        <span class="keywordflow">if</span> (Arrays.equals(FIDELIO_TAG, <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(keyHandle, 0, FIDELIO_TAG.length)) &amp;&amp;</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;                                Arrays.equals(</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;                                        <a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">ArrayTool</a>.<a class="code" href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">subArray</a>(keyHandle, FIDELIO_TAG.length + R_SIZE, mac.getMacLength()),</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;                                        mac.doFinal())) {</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;                            <span class="comment">// calculate the cross sum % 256</span></div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;                            <span class="comment">// could be anything distributing keyhandles across the number space</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                            <span class="keywordtype">int</span> quicksum = 0;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;                            <span class="keywordflow">for</span> (<span class="keyword">final</span> byte b : keyHandle) {</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;                                quicksum += b &amp; 0xFF;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;                            }</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;                            <span class="comment">// use 256 (0 - 255) counters max</span></div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;                            <span class="keyword">final</span> <span class="keywordtype">int</span> ctr = this.globalCounter.apply(quicksum &amp; 0xFF);</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;                            <span class="comment">// final PrivateKey userPrivKey = KeyFactory.getInstance(&quot;EC&quot;)</span></div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;                            <span class="comment">// .generatePrivate(new java.security.spec.ECPrivateKeySpec(</span></div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;                            <span class="comment">// fP.apply(keyHandle).getAsBigInt(), this.attKey.getParams()));</span></div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;                            <span class="keywordflow">return</span> respondSign(0, appIdHash, clientDataHash, ctr, fP.apply(keyHandle), keyHandle);</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;                        }</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;                    }</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;                }</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;                <span class="comment">// no matching keyHandle</span></div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                <span class="keywordflow">throw</span> <span class="keyword">new</span> RuntimeException(<span class="stringliteral">&quot;KeyHandles doesn&#39;t match eID.&quot;</span>);</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (command == 3) {</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                <span class="comment">// what to do?</span></div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            }</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        }</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordflow">throw</span> <span class="keyword">new</span> RuntimeException(<span class="stringliteral">&quot;Invalid request.&quot;</span>);</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    }</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <span class="keyword">private</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a> respondEnroll(<span class="keyword">final</span> <span class="keywordtype">int</span> status, <span class="keyword">final</span> byte[] appIdHash, <span class="keyword">final</span> byte[] clientDataHash,</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;            <span class="keyword">final</span> byte[] userPubKey, <span class="keyword">final</span> byte[] newKeyHandle) <span class="keywordflow">throws</span> GeneralSecurityException {</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a>((byte) status, <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#afa444ffbe0538c59b22516cda23fe590">enrollData</a>(userPubKey, newKeyHandle, <span class="keyword">this</span>.attCert,</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                <span class="keyword">this</span>.cp.S(<span class="keyword">this</span>.attKey, <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a23bd7193e1e09e1af9f94fd78af402c3">enrollSigned</a>(appIdHash, clientDataHash, newKeyHandle, userPubKey))),</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;                <span class="keyword">new</span> byte[0]);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    }</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <span class="keyword">private</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a> respondSign(<span class="keyword">final</span> <span class="keywordtype">int</span> status, <span class="keyword">final</span> byte[] appIdHash, <span class="keyword">final</span> byte[] clientDataHash,</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;            <span class="keyword">final</span> <span class="keywordtype">int</span> ctr, <span class="keyword">final</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_f_i_d_e_l_i_o_secret_key.html">FIDELIOSecretKey</a> key, <span class="keyword">final</span> byte[] keyHandle) <span class="keywordflow">throws</span> GeneralSecurityException {</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">new</span> <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">FIDELIOResponse</a>((byte) status, <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a2419d2b4a830010d50dfb18aa09d2394">authData</a>((byte) 1, ctr,</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;                <span class="keyword">this</span>.cp.S(key, <a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">U2FCodec</a>.<a class="code" href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a1f3caa79eaf942137c167f2f93fb8491">authSigned</a>(appIdHash, (byte) 1, ctr, clientDataHash))),</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;                keyHandle);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    }</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;}</div><div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_html_acaff1853aba4cfcd123859035f114e79"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#acaff1853aba4cfcd123859035f114e79">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.R</a></div><div class="ttdeci">byte [] R(final int n)</div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00092">CryptoProfile.java:92</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_html_a5341de0816b3ab7fb2dae4be7bafb246"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a5341de0816b3ab7fb2dae4be7bafb246">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.Q</a></div><div class="ttdeci">byte [] Q(final FIDELIOSecretKey k)</div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00198">CryptoProfile.java:198</a></div></div>
<div class="ttc" id="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type_html"><div class="ttname"><a href="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type.html">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.Type</a></div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00038">CryptoProfile.java:38</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o_html_aa0b65e3bedf43b1e455ca2ae33bba661"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#aa0b65e3bedf43b1e455ca2ae33bba661">de.bund.bsi.fidelio.poc.service.FIDELIO.FIDELIO</a></div><div class="ttdeci">FIDELIO(final Properties fidoProps)</div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_8java_source.html#l00060">FIDELIO.java:60</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core.html">de.bund.bsi.fidelio.poc.core</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_html"><div class="ttname"><a href="namespacede_1_1persoapp.html">de.persoapp</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_html_a99688f747f4b1eab7c9a46534c5a867b"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a99688f747f4b1eab7c9a46534c5a867b">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.M</a></div><div class="ttdeci">byte [] M(final SecretKey key, final byte[]... data)</div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00126">CryptoProfile.java:126</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o_html_a690597e29e3786b988a326e4ab288dfb"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a690597e29e3786b988a326e4ab288dfb">de.bund.bsi.fidelio.poc.service.FIDELIO.doFIDOeID</a></div><div class="ttdeci">FIDELIOResponse doFIDOeID(final Context ctx, final FIDELIORequest fidoReq)</div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_8java_source.html#l00107">FIDELIO.java:107</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile</a></div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00024">CryptoProfile.java:24</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_response.html">de.bund.bsi.fidelio.poc.core.format.FIDELIOResponse</a></div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_response_8java_source.html#l00003">FIDELIOResponse.java:3</a></div></div>
<div class="ttc" id="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_html"><div class="ttname"><a href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service.html">de.bund.bsi.fidelio.poc.service.TokenKeyService</a></div><div class="ttdef"><b>Definition:</b> <a href="_token_key_service_8java_source.html#l00019">TokenKeyService.java:19</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html">de.bund.bsi.fidelio.poc.service.FIDELIO</a></div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_8java_source.html#l00038">FIDELIO.java:38</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_1_1core_html"><div class="ttname"><a href="namespacede_1_1persoapp_1_1core.html">de.persoapp.core</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service.html">de.bund.bsi.fidelio.poc.service</a></div><div class="ttdef"><b>Definition:</b> <a href="_c_b_o_r_util_8java_source.html#l00001">CBORUtil.java:1</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_f_i_d_e_l_i_o_secret_key_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_f_i_d_e_l_i_o_secret_key.html">de.bund.bsi.fidelio.poc.core.crypto.FIDELIOSecretKey</a></div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_secret_key_8java_source.html#l00009">FIDELIOSecretKey.java:9</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html_a4a210e2647c65a7c2fc7d901dc6b5f45"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html#a4a210e2647c65a7c2fc7d901dc6b5f45">de.persoapp.core.util.ArrayTool.subArray</a></div><div class="ttdeci">static final byte [] subArray(final byte[] b1, final int offset, final int length)</div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00136">ArrayTool.java:136</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format.html">de.bund.bsi.fidelio.poc.core.format</a></div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_request_8java_source.html#l00001">FIDELIORequest.java:1</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc.html">de.bund.bsi.fidelio.poc</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec</a></div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00009">U2FCodec.java:9</a></div></div>
<div class="ttc" id="namespacede_html"><div class="ttname"><a href="namespacede.html">de</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html_a928e2fdf70cada5f0b6dfe324e0d0eae"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a928e2fdf70cada5f0b6dfe324e0d0eae">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec.concat</a></div><div class="ttdeci">static byte [] concat(final List&lt; byte[]&gt; src)</div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00011">U2FCodec.java:11</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html_a23bd7193e1e09e1af9f94fd78af402c3"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a23bd7193e1e09e1af9f94fd78af402c3">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec.enrollSigned</a></div><div class="ttdeci">static byte [] enrollSigned(final byte[] appIdHash, final byte[] clientDataHash, final byte[] keyHandle, final byte[] userPubKey)</div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00047">U2FCodec.java:47</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html_afa444ffbe0538c59b22516cda23fe590"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#afa444ffbe0538c59b22516cda23fe590">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec.enrollData</a></div><div class="ttdeci">static byte [] enrollData(final byte[] userPubKey, final byte[] keyHandle, final X509Certificate cert, final byte[] signature)</div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00053">U2FCodec.java:53</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi.html">de.bund.bsi</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_html_a8f8dbe6962b607a2ea1c9948e809d545"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile.html#a8f8dbe6962b607a2ea1c9948e809d545">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.getInstance</a></div><div class="ttdeci">static CryptoProfile getInstance(final Type profile)</div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00076">CryptoProfile.java:76</a></div></div>
<div class="ttc" id="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type_html_a1b83f6cf7f1d4e333ae69e6052b76371"><div class="ttname"><a href="enumde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_1_1_crypto_profile_1_1_type.html#a1b83f6cf7f1d4e333ae69e6052b76371">de.bund.bsi.fidelio.poc.core.crypto.CryptoProfile.Type.P256</a></div><div class="ttdeci">P256</div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00039">CryptoProfile.java:39</a></div></div>
<div class="ttc" id="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_1_1_context_html"><div class="ttname"><a href="interfacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_token_key_service_1_1_context.html">de.bund.bsi.fidelio.poc.service.TokenKeyService.Context</a></div><div class="ttdef"><b>Definition:</b> <a href="_token_key_service_8java_source.html#l00057">TokenKeyService.java:57</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio.html">de.bund.bsi.fidelio</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_request_html"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1format_1_1_f_i_d_e_l_i_o_request.html">de.bund.bsi.fidelio.poc.core.format.FIDELIORequest</a></div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_request_8java_source.html#l00014">FIDELIORequest.java:14</a></div></div>
<div class="ttc" id="namespacede_1_1persoapp_1_1core_1_1util_html"><div class="ttname"><a href="namespacede_1_1persoapp_1_1core_1_1util.html">de.persoapp.core.util</a></div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00049">ArrayTool.java:49</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1crypto.html">de.bund.bsi.fidelio.poc.core.crypto</a></div><div class="ttdef"><b>Definition:</b> <a href="_crypto_profile_8java_source.html#l00001">CryptoProfile.java:1</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html_a1f3caa79eaf942137c167f2f93fb8491"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a1f3caa79eaf942137c167f2f93fb8491">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec.authSigned</a></div><div class="ttdeci">static byte [] authSigned(final byte[] appIdHash, final byte up, final int i, final byte[] clientDataHash)</div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00061">U2FCodec.java:61</a></div></div>
<div class="ttc" id="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool_html"><div class="ttname"><a href="classde_1_1persoapp_1_1core_1_1util_1_1_array_tool.html">de.persoapp.core.util.ArrayTool</a></div><div class="ttdef"><b>Definition:</b> <a href="_array_tool_8java_source.html#l00059">ArrayTool.java:59</a></div></div>
<div class="ttc" id="namespacede_1_1bund_html"><div class="ttname"><a href="namespacede_1_1bund.html">de.bund</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o_html_a4cdb8a1607536210bd202223dbbf3493"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1service_1_1_f_i_d_e_l_i_o.html#a4cdb8a1607536210bd202223dbbf3493">de.bund.bsi.fidelio.poc.service.FIDELIO.doFIDOeID</a></div><div class="ttdeci">FIDELIOResponse doFIDOeID(final Context ctx, final byte command, final byte[] appIdHash, final byte[] clientDataHash, final List&lt; byte[]&gt; keyHandles)</div><div class="ttdef"><b>Definition:</b> <a href="_f_i_d_e_l_i_o_8java_source.html#l00129">FIDELIO.java:129</a></div></div>
<div class="ttc" id="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec_html_a2419d2b4a830010d50dfb18aa09d2394"><div class="ttname"><a href="classde_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_1_1_u2_f_codec.html#a2419d2b4a830010d50dfb18aa09d2394">de.bund.bsi.fidelio.poc.core.u2f.U2FCodec.authData</a></div><div class="ttdeci">static byte [] authData(final byte up, final int i, final byte[] signature)</div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00069">U2FCodec.java:69</a></div></div>
<div class="ttc" id="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f_html"><div class="ttname"><a href="namespacede_1_1bund_1_1bsi_1_1fidelio_1_1poc_1_1core_1_1u2f.html">de.bund.bsi.fidelio.poc.core.u2f</a></div><div class="ttdef"><b>Definition:</b> <a href="_u2_f_codec_8java_source.html#l00001">U2FCodec.java:1</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_821818eb74338e35a65f6fbb6b6439d5.html">de</a></li><li class="navelem"><a class="el" href="dir_aed0f333c467b9813cdb4ca5bf21300d.html">bund</a></li><li class="navelem"><a class="el" href="dir_346851372df3dc57f10a0e34e7cdb6f5.html">bsi</a></li><li class="navelem"><a class="el" href="dir_1d637c5f431828e7699998ba10862327.html">fidelio</a></li><li class="navelem"><a class="el" href="dir_8ebefae09cc9186ac018f5e9efaf9a56.html">poc</a></li><li class="navelem"><a class="el" href="dir_608a15662f0ef7198fa444f3edd43c1f.html">service</a></li><li class="navelem"><a class="el" href="_f_i_d_e_l_i_o_8java.html">FIDELIO.java</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
